;------------Contact Event PLM version 3.0-------------
;-------------------OmegaDragnet9----------------------

;Restructured the document to make only the first nybble of the High Byte 
;handle the different earthquake and unsetting options.

;This is to free up the rest of the word for the extended events array.

;0000 Set Event 
;1000 Set Event with Earthquake
;2000 Unset Event
;3000 Unset Event with Earthquake

;Events $000-$27F can be set; anything beyond and you get into the collected items part of the array.
;Best to be mindful of boss events and other code relating to the Chozo Block Array.

;Credits:

;JAM for the PLM Template
;MetroidNerd#9001 for Earthquake Script

;Benox50 because the principles here are derived from the Extended Event PLM.
;In fact, the preinstruction contains the same BTS setup that power Benox50'S Extended Event PLM
;so it's even more similar than I had realized.

;JAM and Dewhii100 for the Event Script featured from both of their Event PLMs. 
;Smiley because his Compressed Scroll PLM got me interested in using the Scroll PLM template.

lorom

org $84FBC0							;PLM Location

DW $B371            ;Preinstruction for Scroll PLM 
DW InstructionList 

;------------------------------------------------------------------

InstructionList:

.Loop
DW $86B4
DW .TheMagicHappen 				;Runs Event ASM and Earthquake instead of Scroll ASM
DW $8724,.Loop
DW $86B4

.TheMagicHappen	

PHX : LDA $1DC7,x : PLX : AND #$F000 : CMP #$3000 : BEQ .UnsetEventCheck
PHX : LDA $1DC7,x : PLX : AND #$F000 : CMP #$2000 : BEQ .UnsetEventCheck

	
;Checks if events have been set. Only branches if they've not been set. Otherwise goes to RTS (so PLM doesn't keep causing earthquake.) 
PHX
LDA $1DC7,x		;PLM variable (event # to set)
PLX
AND #$0FFF
JSL $808233
BCC .CheckEarthquake1
RTS

.CheckEarthquake1
PHX : LDA $1DC7,x : PLX : AND #$F000 : CMP #$1000 : BNE .Event
JSR .Earthquake
JSR .Event
RTS

.UnsetEventCheck
;Checks if events have already been set. Only branches if set.
PHX
LDA $1DC7,x		;PLM variable (event # to set)
PLX
AND #$0FFF
JSL $808233
BCS .CheckEarthquake2
RTS

.CheckEarthquake2
PHX : LDA $1DC7,x : PLX : AND #$F000 : CMP #$3000 : BNE .UnsetEvent
JSR .Earthquake
JSR .UnsetEvent
RTS

.Earthquake
STZ $07DF
LDA #$0006
STA $183E
LDA #$0046 
STA $1840
LDA #$0046
JSL $8090CB
RTS

.UnsetEvent
PHX
;LDX $1C27		;PLM index
LDA $1DC7,x		;PLM variable (event # to set)
PLX
AND #$0FFF
JSL $808212
RTS 

.Event
PHX
;LDX $1C27		;PLM index
LDA $1DC7,x		;PLM variable (event # to set)
PLX
AND #$0FFF
JSL $8081FA		;Set event A
RTS



